<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src/input/input_hlo_json.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>input_hlo_json.rs - source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled ><script id="default-settings"></script><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="icon" type="image/svg+xml" href="../../../favicon.svg">
<link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png">
<link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../HPGO/index.html'><div class='logo-container rust-logo'><img src='../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices" role="menu"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" class="help-button">?</button>
                <a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="kw">super</span>::<span class="ident">HLOJsonImporter</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">hlo_json</span>::<span class="ident">hlo_ast</span>;

<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">hlo_json</span>::<span class="ident">hlo_ast</span>::<span class="ident">HLORoot</span>;
<span class="kw">use</span> <span class="ident">log</span>::<span class="ident">debug</span>;
<span class="kw">use</span> <span class="ident">rayon</span>::<span class="ident">prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">error</span>::<span class="ident">Error</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">fs</span>::<span class="ident">File</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">io</span>::<span class="ident">BufReader</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">path</span>::<span class="ident">Path</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">time</span>::<span class="ident">Instant</span>;

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">const</span> <span class="ident">VERBOSE</span>: <span class="ident">bool</span> <span class="op">=</span> <span class="bool-val">true</span>;

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">HLOStructuredJsonImporter</span> {}

<span class="kw">impl</span> <span class="ident">HLOJsonImporter</span> <span class="kw">for</span> <span class="ident">HLOStructuredJsonImporter</span> {
    <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">HLOStructuredJsonImporter</span> {
        <span class="ident">HLOStructuredJsonImporter</span> {}
    }

    <span class="kw">fn</span> <span class="ident">ImportFrom</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">filename</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">hlo_ast</span>::<span class="ident">HLORoot</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="macro">debug</span><span class="macro">!</span>(<span class="string">&quot;[input]\tImporting Participle Json from Go...&quot;</span>);
        <span class="kw">let</span> <span class="ident">now</span> <span class="op">=</span> <span class="ident">Instant</span>::<span class="ident">now</span>();
        <span class="kw">let</span> <span class="ident">file</span> <span class="op">=</span> <span class="ident">File</span>::<span class="ident">open</span>(<span class="ident">Path</span>::<span class="ident">new</span>(<span class="ident">filename</span>))<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">reader</span> <span class="op">=</span> <span class="ident">BufReader</span>::<span class="ident">new</span>(<span class="ident">file</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">ast_root</span>: <span class="ident">HLORoot</span> <span class="op">=</span> <span class="ident">serde_json</span>::<span class="ident">from_reader</span>(<span class="ident">reader</span>)<span class="question-mark">?</span>;
        <span class="comment">// augment function param name with %</span>
        <span class="ident">ast_root</span>.<span class="ident">functions</span>.<span class="ident">par_iter_mut</span>().<span class="ident">for_each</span>(<span class="op">|</span><span class="ident">f</span><span class="op">|</span> {
            <span class="ident">f</span>.<span class="ident">params</span>.<span class="ident">iter_mut</span>().<span class="ident">for_each</span>(<span class="op">|</span><span class="ident">p</span><span class="op">|</span> {
                <span class="ident">p</span>.<span class="ident">augment_name</span>();
            });
        });
        <span class="macro">println</span><span class="macro">!</span>(
            <span class="string">&quot;[input]\t Reading from Go-generated Participle Json... {}ms&quot;</span>,
            <span class="ident">now</span>.<span class="ident">elapsed</span>().<span class="ident">as_millis</span>()
        );
        <span class="prelude-val">Ok</span>(<span class="ident">ast_root</span>)
    }

    <span class="kw">fn</span> <span class="ident">ImportFromString</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">json_str</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">hlo_ast</span>::<span class="ident">HLORoot</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="macro">debug</span><span class="macro">!</span>(<span class="string">&quot;[input]\tImporting Participle Json from Go...&quot;</span>);
        <span class="kw">let</span> <span class="ident">now</span> <span class="op">=</span> <span class="ident">Instant</span>::<span class="ident">now</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">ast_root</span>: <span class="ident">HLORoot</span> <span class="op">=</span> <span class="ident">serde_json</span>::<span class="ident">from_str</span>(<span class="ident">json_str</span>)<span class="question-mark">?</span>;
        <span class="comment">// augment function param name with %</span>
        <span class="ident">ast_root</span>.<span class="ident">functions</span>.<span class="ident">par_iter_mut</span>().<span class="ident">for_each</span>(<span class="op">|</span><span class="ident">f</span><span class="op">|</span> {
            <span class="ident">f</span>.<span class="ident">params</span>.<span class="ident">iter_mut</span>().<span class="ident">for_each</span>(<span class="op">|</span><span class="ident">p</span><span class="op">|</span> {
                <span class="ident">p</span>.<span class="ident">augment_name</span>();
            });
        });
        <span class="macro">println</span><span class="macro">!</span>(
            <span class="string">&quot;[input]\t Reading from Go-generated Participle Json... {}ms&quot;</span>,
            <span class="ident">now</span>.<span class="ident">elapsed</span>().<span class="ident">as_millis</span>()
        );
        <span class="prelude-val">Ok</span>(<span class="ident">ast_root</span>)
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "HPGO";</script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>